#include "datastream.h"

DataStream::DataStream()
{
}

DataStream::DataStream(QVector<quint8> &data)
{
    this->data=data;
    this->pos=0;
}
void DataStream::close(QVector<quint8> &data)
{
    data=this->data;
}
DataStream &operator>>(DataStream &in, quint8 &value)
{
    value=in.data[in.pos];
    in.pos++;
    return in;
}
DataStream &operator>>(DataStream &in, quint16 &value)
{
    value=in.data[in.pos]+(in.data[in.pos+1]<<8);
    in.pos+=2;
    return in;
}
DataStream &operator>>(DataStream &in, quint32 &value)
{
    value=in.data[in.pos]+(in.data[in.pos+1]<<8)+(in.data[in.pos+2]<<16)+(in.data[in.pos+3]<<24);
    in.pos+=4;
    return in;
}
DataStream &operator>>(DataStream &in, qint8 &value)
{
    value=in.data[in.pos];
    if(value>>7==1)
    {
        value-=0x100;
    }
    in.pos++;
    return in;
}
DataStream &operator>>(DataStream &in, qint16 &value)
{
    value=in.data[in.pos]+(in.data[in.pos+1]<<8);
    if(value>>15==1)
    {
        value-=0x10000;
    }
    in.pos+=2;
    return in;
}
DataStream &operator>>(DataStream &in, qint32 &value)
{
    value=in.data[in.pos]+(in.data[in.pos+1]<<8)+(in.data[in.pos+2]<<16)+(in.data[in.pos+3]<<24);
    if (value>>31==1)
    {
        value-=0x100000000;
    }
    in.pos+=4;
    return in;
}
DataStream &operator<<(DataStream &in, quint16 &value)
{
    in.data[in.pos]=(quint8)((value>>0)&0xFF);
    in.data[in.pos+1]=(quint8)((value>>8)&0xFF);
    in.pos+=2;
    return in;
}
DataStream &operator<<(DataStream &in, quint32 &value)
{
    in.data[in.pos]=(quint8)((value>>0)&0xFF);
    in.data[in.pos+1]=(quint8)((value>>8)&0xFF);
    in.data[in.pos+2]=(quint8)((value>>16)&0xFF);
    in.data[in.pos+3]=(quint8)((value>>24)&0xFF);
    in.pos+=4;
    return in;
}
