#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include <QMainWindow>
#include <QFileDialog>
#include <QTextStream>
#include "narc.h"
#include "datastream.h"
#include <QMap>

namespace Ui {
    class MainWindow;
}

class MainWindow : public QMainWindow {
    Q_OBJECT
public:
    MainWindow(QWidget *parent = 0);
    ~MainWindow();

protected:
    void changeEvent(QEvent *e);

private:
    Ui::MainWindow *ui;
    Narc narc;
    QString narcName;
    QString fileName;
    QVector<quint8> makeSection(QStringList strings,int numEntries);
    QList<quint16> parseString(QString string,int entry_id);
    QList<quint16> keys;
    QList<quint16> unknowns;
    QStringList getStrings(int m,int i);
    void saveEntry(QString string,int m,int i);
    void report(QString string);
private slots:
    void openNarc();
    void writeToNarc();
    void typeChanged();
    void loadEntryFromNarc();
    void saveEntry();
    void exportToFiles();
    void exportToFile();
    void importFromFiles();
};

#endif // MAINWINDOW_H
