#include "narc.h"

QDataStream &operator<<(QDataStream &out, Narc *narc)
{
    narc->btafSize=narc->gmifSize=0;
    narc->startOffsets.clear();
    narc->endOffsets.clear();
    int offset=0;
    for(int i=0;i<narc->numEntries;i++)
    {
        narc->startOffsets.append(offset);
        offset+=narc->fileData[i].size();
        narc->endOffsets.append(offset);
        offset+=(4-(narc->fileData[i].size()%4))%4;
    }
    narc->btafSize=12+8*narc->numEntries;
    narc->gmifSize=offset+8;
    narc->size=narc->gmifSize+narc->btnfSize+narc->btafSize+narc->headerSize;
    out<<narc->magic<<narc->unk1<<narc->unk2<<narc->size<<narc->headerSize<<narc->unk3<<narc->btaf<<narc->btafSize<<narc->numEntries;
    for(int i=0;i<narc->numEntries;i++)
    {
        out<<narc->startOffsets[i]<<narc->endOffsets[i];
    }
    out<<narc->btnf<<narc->btnfSize<<narc->unk4<<narc->unk5<<narc->gmif<<narc->gmifSize;
    quint8 tmp=0;
    for(int i=0;i<narc->numEntries;i++)
    {
        for(int k=0;k<narc->fileData[i].size();k++)
        {
            out<<narc->fileData[i][k];
        }
        for(int j=0;j<(4-(narc->fileData[i].size()%4))%4;j++)
        {
            out<<tmp;
        }
    }
    return out;
}

QDataStream &operator>>(QDataStream &in, Narc *narc)
{
    in>>narc->magic>>narc->unk1>>narc->unk2>>narc->size>>narc->headerSize>>narc->unk3>>narc->btaf>>narc->btafSize>>narc->numEntries;
    narc->startOffsets.fill(0,narc->numEntries);
    narc->endOffsets.fill(0,narc->numEntries);
    for(quint32 i=0;i<narc->numEntries;i++)
    {
        in>>narc->startOffsets[i]>>narc->endOffsets[i];
    }
    in>>narc->btnf>>narc->btnfSize>>narc->unk4>>narc->unk5>>narc->gmif>>narc->gmifSize;
    quint8 tmp;
    quint32 size;
    for(quint32 i=0;i<narc->numEntries;i++)
    {
        size=narc->endOffsets.at(i)-narc->startOffsets.at(i);
        QVector<quint8> temp(size);
        narc->fileData.append(temp);
        for(quint32 j=0;j<size;j++)
        {
            in>>narc->fileData[i][j];
        }
        for(quint32 j=0;j<(4-(size%4))%4;j++)
        {
            in>>tmp;
        }
    }
    return in;
}

Narc::Narc()
{

}

Narc::Narc(QFile &file,quint32 offset)
{
    file.seek(offset);
    QDataStream ds(&file);
    ds.setByteOrder(QDataStream::LittleEndian);
    ds>>this;
}

void Narc::writeNarc(QFile &file, quint32 offset)
{
    file.seek(offset);
    QDataStream ds(&file);
    ds.setByteOrder(QDataStream::LittleEndian);
    ds<<this;
}
